<?php

defined('_JEXEC') or die;

/**
 * Class CformsProduct
 *
 * @since  1.0.0
 */
class CformsProduct extends CProduct
{
	/**
	 * Get the extension name
	 *
	 * @return  string
	 *
	 * @since   1.0.0
	 */
	public function getExtensionName()
	{
		return 'CForms';
	}

	/**
	 * Get the product icon (fa or image)
	 *
	 * @return  mixed
	 *
	 * @since   __DEPLOY_VERSION__
	 */
	public function getIcon()
	{
		return 'media/com_cinstaller/images/extensions/cforms.png';
	}

	/**
	 * Get the component name (e.g. com_matukio)
	 *
	 * @return  string
	 *
	 * @since   __DEPLOY_VERSION__
	 */
	public function getComponentIdentifier()
	{
		return 'com_cforms';
	}

	/**
	 * Get the extension name
	 *
	 * @return  CInstallerRequirements
	 *
	 * @since   1.0.0
	 */
	public function getRequirements()
	{
		$requirements = new CInstallerRequirements();

		return $requirements;
	}

	/**
	 * Does the extension require a download Id
	 *
	 * @return  bool
	 *
	 * @since   1.0.0
	 */
	public function needsDownloadId()
	{
		return true;
	}

	/**
	 * Is it a top / featured product?
	 *
	 * @return  boolean
	 *
	 * @since   __DEPLOY_VERSION__
	 */
	public function isTopProduct()
	{
		return true;
	}

	/**
	 * Get the sample data
	 *
	 * @return  array
	 *
	 * @since   1.0.0
	 */
	public function getSampleData()
	{
		return null;
	}

	/**
	 * Get the localization options
	 *
	 * @return  array
	 *
	 * @since   1.0.0
	 */
	public function getLocalizationOptions()
	{
		return null;
	}

	/**
	 * Get the ARS category id
	 *
	 * @return  int
	 *
	 * @since   1.0.0
	 */
	public function getArsCategory()
	{
		return 41;
	}

	/**
	 * Get the update Server URL (we use this to get the latest version)
	 *
	 * @return  string
	 *
	 * @since   1.0.0
	 */
	public function getUpdateServer()
	{
		return 'https://compojoom.com/index.php?option=com_ars&view=update&task=stream&format=xml&id=28&dummy=extension.xml';
	}

	/**
	 * Get the youtube video shown at the last page of the install
	 *
	 * @return  string
	 *
	 * @since   __DEPLOY_VERSION__
	 */
	public function getYoutubeVideo()
	{
		return null;
	}

	/**
	 * Get the redirect URL string
	 *
	 * @return  string
	 *
	 * @since   1.0.0
	 */
	public function getRedirectUrl()
	{
		return 'index.php?option=com_cforms';
	}
}
