<?php

defined('_JEXEC') or die;

/**
 * Class CmcProduct
 *
 * @since  1.0.0
 */
class CmcProduct extends CProduct
{
	/**
	 * Get the extension name
	 *
	 * @return  string
	 *
	 * @since   1.0.0
	 */
	public function getExtensionName()
	{
		return 'CMC';
	}

	/**
	 * Get the product icon (fa or image)
	 *
	 * @return  mixed
	 *
	 * @since   __DEPLOY_VERSION__
	 */
	public function getIcon()
	{
		return 'fa fa-envelope-o';
	}

	/**
	 * Does the extension require a download Id
	 *
	 * @return  bool
	 *
	 * @since   1.0.0
	 */
	public function needsDownloadId()
	{
		return false;
	}

	/**
	 * Get the component name (e.g. com_matukio)
	 *
	 * @return  string
	 *
	 * @since   __DEPLOY_VERSION__
	 */
	public function getComponentIdentifier()
	{
		return 'com_cmc';
	}

	/**
	 * Get the update Server URL (we use this to get the latest version)
	 *
	 * @return  string
	 *
	 * @since   1.0.0
	 */
	public function getUpdateServer()
	{
		return 'https://compojoom.com/index.php?option=com_ars&view=update&task=stream&format=xml&id=13&dummy=extension.xml';
	}

	/**
	 * Get the extension name
	 *
	 * @return  CInstallerRequirements
	 *
	 * @since   1.0.0
	 */
	public function getRequirements()
	{
		$requirements = new CInstallerRequirements();

		return $requirements;
	}

	/**
	 * Get the redirect URL string
	 *
	 * @return  string
	 *
	 * @since   1.0.0
	 */
	public function getRedirectUrl()
	{
		return 'index.php?option=com_cmc';
	}

	/**
	 * Get the sample data
	 *
	 * @return  array
	 *
	 * @since   1.0.0
	 */
	public function getSampleData()
	{
		return [];
	}

	/**
	 * Get the localization options
	 *
	 * @return  array
	 *
	 * @since   1.0.0
	 */
	public function getLocalizationOptions()
	{
		return [];
	}

	/**
	 * Get the ARS category id
	 *
	 * @return  int
	 *
	 * @since   1.0.0
	 */
	public function getArsCategory()
	{
		return 21;
	}

	/**
	 * Get the youtube video shown at the last page of the install
	 *
	 * @return  string
	 *
	 * @since   __DEPLOY_VERSION__
	 */
	public function getYoutubeVideo()
	{
		return '6fZAdVln0Fg';
	}

	/**
	 * Is it a top / featured product?
	 *
	 * @return  boolean
	 *
	 * @since   __DEPLOY_VERSION__
	 */
	public function isTopProduct()
	{
		return false;
	}


}
