<?php
defined('_JEXEC') or die;

use Joomla\Registry\Registry;

require_once __DIR__ . '/requirement.php';

/**
 * Class CInstallerRequirements
 *
 * @since  1.0.0
 */
class CInstallerRequirements extends Registry
{
	/**
	 * CInstallerRequirements constructor.
	 *
	 * @param   array  $params  Optional override params
	 *
	 * @since   1.0.0
	 */
	public function __construct($params = array())
	{
		if (!count($params))
		{
			$params = array(
				Requirement::create('phpMin', '5.3.10'),
				Requirement::create('phpOptimum', '7.0.16', false),
				Requirement::create('phpCurl', '7.0.0'),
				Requirement::create('joomlaMin', '3.6.5'),
				Requirement::create('databaseServer', array('mysql', 'mariadb')),
				Requirement::create('mysqlMin', '5.5.0'),
				Requirement::create('mysqlOptimum', '5.6.0', false),
				Requirement::create('mysqlDriver', array('mysql', 'mysqli')),
				Requirement::create('phpModules', array('curl'))
			);
		}

		parent::__construct($params);
	}

	/**
	 * Override a value in the requirements
	 *
	 * @param   string  $name   Requirement name
	 * @param   mixed   $value  Requirement value
	 *
	 * @return  void
	 *
	 * @since   1.0.0
	 */
	public function set($name, $value, $separator = null)
	{
		$it = $this->getIterator();

		$found = false;

		foreach ($it as $entry)
		{
			if ($entry->name == $name)
			{
				$entry->target = $value;
				$found = true;
			}
		}

		if (!$found)
		{
			$it->append(Requirement::create($name, $value));
		}
	}
}
