<?php

defined('_JEXEC') or die;

/**
 * Class CInstallerModelChoose
 *
 * @since  1.0.0
 */
class CInstallerModelChoose extends JModelLegacy
{
	/**
	 * Get the product the installation is running for
	 *
	 * @return  CProductInterface[]
	 *
	 * @since   1.0.0
	 *
	 * @throws  Exception  If no product file is found
	 */
	public function getProducts()
	{
		$productDir = JPATH_COMPONENT_ADMINISTRATOR . '/installer/product/';

		// Bit magic on finding the files
		$dir = new DirectoryIterator($productDir);
		$target = null;

		$products = [];
		$topProducts = [];

		foreach ($dir as $fileinfo)
		{
			if ($fileinfo->isDot())
			{
				continue;
			}

			// There should be only one file in
			$target = $fileinfo->getFilename();

			$path = JPATH_COMPONENT_ADMINISTRATOR . '/installer/product/' . $target;

			require_once $path;

			$extension = str_replace('.php', '', $target);
			$className = ucfirst(str_replace('-', '', $extension)) . 'Product';

			/** @var CProductInterface $product */
			$product = new $className;

			$product->identifier = $extension;

			// Order by top products
			if ($product->isTopProduct())
			{
				$topProducts[] = $product;
			}
			else
			{
				$products[] = $product;
			}
		}

		$products = array_merge($topProducts, $products);

		if (empty($products))
		{
			throw new Exception('No product file found',500);
		}

		return $products;
	}
}
