<?php

defined('_JEXEC') or die;

/**
 * Class CInstallerModelInstall
 *
 * @since  1.0.0
 */
class CInstallerModelInstall extends JModelLegacy
{
	/**
	 * Get the product the installation is running for
	 *
	 * @return  CProductInterface
	 *
	 * @since   1.0.0
	 *
	 * @throws  Exception  If no product file is found
	 */
	public function getProduct($name)
	{
		$productDir = JPATH_COMPONENT_ADMINISTRATOR . '/installer/product/';

		// Bit magic on finding the files
		$dir = new DirectoryIterator($productDir);
		$target = null;

		foreach ($dir as $fileinfo)
		{
			if ($fileinfo->isDot())
			{
				continue;
			}

			// There should be only one file in
			if ($fileinfo->getFilename() == $name . '.php')
			{
				$target = $fileinfo->getFilename();

				break;
			}
		}

		if (empty($target))
		{
			throw new Exception('No product file found',500);
		}

		$path = JPATH_COMPONENT_ADMINISTRATOR . '/installer/product/' . $target;

		require_once $path;

		$extension = str_replace('.php', '', $target);
		$className = ucfirst(str_replace('-', '', $extension)) . 'Product';

		$product = new $className;

		$product->identifier = $extension;

		return $product;
	}
}
