<?php

defined('_JEXEC') or die;

CompojoomHtmlBehavior::bootstrap();

JHTML::_('stylesheet', 'media/com_cinstaller/css/install.css');
JHTML::_('script', 'media/com_cinstaller/js/jquery.ajaxfileupload.js');

/** @var CProductInterface $product */
$product = $this->product;

$sampleData = $product->getSampleData();
$localData  = $product->getLocalizationOptions();

$hasSampleLocal = !empty($sampleData) || !empty($localData);
$navSize = $hasSampleLocal ? '3' : '4';
?>

<div id="cinstaller" class="compojoom-bootstrap">

	<div class="container">
		<div id="top">
			<div id="nav_container">
				<nav id="nav_heading">
					<div class="row">
						<div id="install-step1" class="col-sm-<?php echo $navSize ?> active install-step">
							<div class="install-element">
								<div class="row">
									<div class="col-sm-2">
										<h1>1</h1>
									</div>
									<div class="col-sm-10">
										<h3><?php echo JText::_('COM_CINSTALLER_START'); ?></h3>
										<?php echo JText::_('COM_CINSTALLER_CONFIGURE_THE_INSTALLER'); ?>
									</div>
								</div>
							</div>
						</div>
						<div id="install-step2" class="col-sm-<?php echo $navSize ?> install-step">
							<div class="row">
								<div class="install-element">
									<div class="col-sm-2">
										<h1>2</h1>
									</div>
									<div class="col-sm-10">
										<h3><?php echo JText::_('COM_CINSTALLER_INSTALLATION'); ?></h3>
										<?php echo JText::_('COM_CINSTALLER_SET_EVERYTHING_UP'); ?>
									</div>
								</div>
							</div>
						</div>
						<?php if ($hasSampleLocal): ?>
							<div id="install-step3" class="col-sm-3 install-step">
								<div class="row">
									<div class="install-element">
										<div class="col-sm-2">
											<h1>3</h1>
										</div>
										<div class="col-sm-10">
											<h3><?php echo JText::_('COM_CINSTALLER_SAMPLE_DATA'); ?></h3>
											<?php echo JText::_('COM_CINSTALLER_AND_EXTENSION_CONFIGURATION'); ?>
										</div>
									</div>
								</div>
							</div>
						<?php endif; ?>
						<div id="install-step4" class="col-sm-<?php echo $navSize ?> install-step">
							<div class="row">
								<div class="install-element">
									<div class="col-sm-2">
										<h1><?php echo $hasSampleLocal ? '4' : '3' ?></h1>
									</div>
									<div class="col-sm-10">
										<h3><?php echo JText::_('COM_CINSTALLER_READY'); ?></h3>
										<?php echo JText::_('COM_CINSTALLER_GETTING_STARTED'); ?>
									</div>
								</div>
							</div>
						</div>
					</div>
				</nav>
			</div>
		</div>

		<div id="page1" class="page text-left">

			<div class="page-intro install-form">
				<h3>
					<?php echo $this->product->getExtensionName(); ?>
					<?php echo JText::_('COM_CINSTALLER_INSTALLATION'); ?>
				</h3>
				<p>
					<?php echo JText::_('COM_CINSTALLER_WELCOME_TO_THE_INSTALLATION_OF'); ?> <?php echo $this->product->getExtensionName(); ?> <?php echo JText::_('COM_CINSTALLER_FROM_COMPOJOOM'); ?>
					.

					<?php if ($product->needsDownloadId()) : ?>
						<br/>
						<?php echo JText::_('COM_CINSTALLER_GET_YOUR_DOMAIN_KEY_AT'); ?>
						<a href="https://compojoom.com/my-domains">https://compojoom.com/my-domains</a>
					<?php endif; ?>
				</p>
			</div>

			<div class="install-form">
				<?php if ($product->needsDownloadId()) : ?>
					<div class="download_id">
						<label for="download_id">
							<?php echo JText::_('COM_CINSTALLER_YOUR_DOWNLOAD_ID'); ?>
						</label>
						<div class="control-input">
							<input type="text" id="download_id" class="form-control input-lg"
							       placeholder="Get it at compojoom.com"/>
						</div>
					</div>
				<?php endif; ?>
				<div id="upload_package">
					<div class="text-right">
						<a id="btnShowUpload" href="#"><?php echo JText::_('COM_MATUKIO_OR_UPLOAD_THE_FULL_PACKAGE'); ?></a>
					</div>
					<div id="upload_package_area" style="display: none">
						<form enctype="multipart/form-data" name="packageUpload" id="packageUpload">
							<input type="file" class="form-control" name="fileupload" id="file-upload"/>

							<input type="hidden" id="upload-file-name" value=""/>

							<div id="infoUploading" class="alert alert-info" style="display: none;">
								<?php echo JText::_('COM_CINSTALLER_UPLOADING_FILE'); ?>
							</div>
							<div id="infoUploadDone" class="alert alert-success" style="display: none;">
								<?php echo JText::_('COM_CINSTALLER_FILE_UPLOADED_SUCCESSFULL'); ?>
							</div>
						</form>
					</div>

				</div>
			</div>

			<div class="requirements">
				<h3><?php echo JText::_('COM_CINSTALLER_EXTENSION_REQUIREMENTS'); ?></h3>

				<div class="row">
					<?php
					$requirements = CInstallerHelperRequirements::getInstance($product)->get();

					foreach ($requirements as $requirement) :
						?>
						<div class="col-sm-6">
							<table class="table">
								<tr>
									<td style="width: 50%">
										<?php echo JText::_('COM_CINSTALLER_' . mb_strtoupper($requirement->name)); ?>
										<?php echo $requirement->isRequired ? ' *' : ''; ?>
									</td>
									<td style="width: 15%">
										<i class="icon-<?php echo $requirement->isFullfilled ? 'checkmark-2 icon-green' : 'delete icon-red'; ?>"></i>
									</td>
									<td style="width: 22%">
										<?php
										if (!is_array($requirement->target))
										{
											echo $requirement->target;
										}
										else
										{
											echo implode(', ', $requirement->target);
										}
										?>
									</td>
									<td style="width: 22%">
										<?php
										if (!is_array($requirement->currentVersion))
										{
											if (strlen($requirement->currentVersion) > 10)
											{
												echo substr($requirement->currentVersion, 0, 10) . ' ..';
											}
											else
											{
												echo $requirement->currentVersion;
											}
										}
										else
										{
											echo substr(implode(', ', $requirement->currentVersion), 0, 10);
										}
										?>
									</td>
								</tr>
							</table>
						</div>

					<?php endforeach; ?>
				</div>
			</div>
		</div> <!-- // page-1 -->

		<div id="page2" class="page">
			<h3><?php echo JText::_('COM_CINSTALLER_INSTALLATION'); ?></h3>
			<p>
				<?php echo $product->getExtensionName() . ' ' . JText::_('COM_CINSTALLER_IS_CURRENTLY_INSTALLED'); ?>
			</p>
			<div id="install_progress">
				<div class="progress">
					<div id="install_progress_bar" class="progress-bar progress-bar-success progress-bar-striped"
					     role="progressbar" aria-valuenow="60" aria-valuemin="0" aria-valuemax="100" style="width: 60%">
						<span class="sr-only">99% Complete (success)</span>
					</div>
				</div>
			</div>
			<div id="install_message" style="display: none;">
				<div class="alert alert-info">
					<?php
					echo $product->getExtensionName() . ' ' . JText::_('COM_CINSTALLER_HAS_BEEN_SUCCESSFULLY_ISNTALLED')
					?>
				</div>
			</div>

		</div><!-- // page2 -->

		<div id="page3" class="page">
			<div id="sample_data" class="install-form">
				<h3><?php echo JText::_('COM_MATUKIO_SAMPLE_DATA_AND_CONFIGURATION'); ?></h3>

				<?php if (!empty($sampleData)) :?>
					<label for="sample_data_install"><?php echo JText::_('COM_CINSTALLER_SAMPLE_DATA'); ?></label>

					<select id="sample_data_install" name="sample_data_install" class="form-control">
						<?php
						foreach ($sampleData as $sample)
						{
							echo '<option value="' . $sample['name'] . '">' . JText::_('COM_CINSTALLER_' . strtoupper($sample['name'])) . '</option>';
						}
						?>
					</select>
				<?php endif; ?>
			</div>
			<div id="local_settings" class="install-form">
				<?php if (!empty($localData)) : ?>
					<label for="localization_options"><?php echo JText::_('COM_CINSTALLER_LOCALIZATION_OPTIONS'); ?></label>

					<select id="localization_options" name="localization_options" class="form-control">
						<?php
						foreach ($localData as $option)
						{
							echo '<option value="' . $option['name'] . '">' . JText::_('COM_CINSTALLER_' . strtoupper($option['name'])) . '</option>';
						}
						?>
					</select>
				<?php endif; ?>
			</div>
		</div><!-- // page3 -->

		<div id="page4" class="page">
			<div class="install-form">
				<h3><?php echo JText::_('COM_CINSTALLER_INSTALLATION_FINISHED'); ?></h3>

				<p>
					<?php echo JText::_('COM_CINSTALLER_THANK_YOU_FOR_CHOOSING_COMPOJOOM'); ?>
				</p>
				<strong><?php echo JText::_('COM_CINSTALLER_DOCUMENTATION_RESOURCES'); ?></strong>
				<ul>
					<li><a href="https://compojoom.com/">Documentation</a></li>
					<li><a href="https://youtube.com/user/compojoom">Youtube</a></li>
				</ul>
				<strong><?php echo JText::_('COM_CINSTALLER_SUPPORT'); ?></strong>
				<ul>
					<li><a href="https://compojoom.com/support/support-tickets">Ticket system</a></li>
					<li><a href="https://compojoom.com/support/forum">Forum</a></li>
				</ul>
				<strong><?php echo JText::_('COM_CINSTALLER_NEWS'); ?></strong>
				<ul>
					<li><a href="https://compojoom.com/blog">Blog</a></li>
					<li><a href="https://facebook.com/compojoom/?ref=extension">Facebook</a></li>
					<li><a href="https://twitter.com/compojoom/?ref=extension">Twitter</a></li>
				</ul>
				<div class="extension-video text-center">
					<iframe width="640" height="360"
					        src="https://www.youtube.com/embed/<?php echo $product->getYoutubeVideo(); ?>"
					        frameborder="0" allowfullscreen></iframe>
				</div>
			</div>
		</div><!-- // page4 -->

		<nav id="nav_buttons">
			<div class="pull-right">
				<button id="btnNext" class="btn btn-success"><?php echo JText::_('JNEXT'); ?></button>
				<a id="btnFinish" class="btn btn-success"
				   href="<?php echo JRoute::_('index.php?option=com_cinstaller&task=install.finish&product=' . $product->identifier); ?>"
				   style="display: none;"><?php echo JText::_('COM_CINSTALLER_FINISH'); ?></a>
			</div>
		</nav>

	</div>
</div>

<script>
	// TODO cleanup and refactor to plugin
	jQuery(document).ready(function ($) {
		var downloaded = false;
		var page = 1;
		var hasSample = <?php echo $hasSampleLocal ? 1 : 0; ?>;

		var $btnNext = $('#btnNext');

		function nextPage() {
			if (page === 1) {
				var res = install();

				if (res == false) {
					return;
				}
			}

			if (page === 2) {
				if (hasSample === 0) {
					page++;
				}
			}

			if (page === 3) {
				var res = sampleData();

				if (res == false) {
					return;
				}

				$btnNext.hide();
				$('#btnFinish').show();
			}

			page++;

			$('.install-step').removeClass('active');
			$('#install-step' + page).addClass('active');
			$('.page').hide();
			$('#page' + page).show();
		}

		function sampleData() {
			var sampleData = $('#sample_data_install').val();
			var localizationData = $('#localization_options').val();

			console.log(sampleData);
			console.log(localizationData);

			$.ajax('index.php?option=com_cinstaller&task=install.sampledata', {
				method: 'post',
				data: {
					product: '<?php echo $product->identifier; ?>',
					sample_data: sampleData,
					localization_data: localizationData
				}
			}).done(function (data) {
				console.log(data);
				if (data.error) {
					alert('<?php echo JText::_('COM_CINSTALLER_ERROR_INSTALLING_SAMPLE_DATA', true); ?> ' + data.message);
					return;
				}
			}).fail(function (jqXHR, textStatus) {
				alert('<?php echo JText::_('COM_CINSTALLER_ERROR_INSTALLING_SAMPLE_DATA', true); ?> ' + textStatus);
			});
		}

		function install() {
			$btnNext.prop('disabled', true);

			var downloadKey = $('#download_id').val();
			var uploadFileName  = $('#upload-file-name').val();

			if (!uploadFileName.length && $('#download_id').length && downloadKey.length < 10) {
				$btnNext.prop('disabled', false);
				alert('<?php echo JText::_('COM_CINSTALLER_INVALID_KEY', true); ?>');
				return false;
			}

			$.ajax('index.php?option=com_cinstaller&task=install.install', {
				method: 'post',
				data: {
					product: '<?php echo $product->identifier; ?>',
					installation_key: downloadKey,
					upload_file_name: uploadFileName
				}
			}).done(function (data) {
				if (data.error) {
					alert('<?php echo JText::_('COM_CINSTALLER_ERROR_INSTALLING_EXTENSION', true); ?> ' + data.message);
					$btnNext.prop('disabled', false);
					return false;
				}

				$('#install_progress_bar').css({width: '100%'});
				$('#install_message').show();
				$btnNext.prop('disabled', false);

				downloaded = true;
			}).fail(function (jqXHR, textStatus) {
				alert('<?php echo JText::_('COM_CINSTALLER_ERROR_INSTALLING_EXTENSION', true); ?> ' + textStatus);
			});

			// Async, but at least validation was successful
			return true;
		}

		$('#file-upload').ajaxfileupload({
			action: 'index.php?option=com_cinstaller&task=install.upload',
			valid_extensions: ['zip'],
			onComplete: function (response) {
				if (response.status == 'error') {
					alert('<?php echo JText::_('COM_CINSTALLER_FILE_UPLOAD_FAILED', true); ?> ' + response.error_message);
					return;
				}

				$('#upload-file-name').val(response.filename);
				$('#infoUploading').hide();
				$('#infoUploadDone').show();
				$btnNext.prop('disabled', false);
			},
			onStart: function () {
				$btnNext.prop('disabled', true);
				$('#infoUploading').show();
			}
		});

		$('#btnShowUpload').click(function (e) {
			e.preventDefault();

			$('#upload_package_area').toggle(100);
		});

		$btnNext.click(function (e) {
			nextPage();
		});
	});

</script>